<template>
<div>
 <button style="margin-left:20%;" type="button" class="btn btn-primary" data-toggle="modal" data-target="#modalcompraprov">+ Nueva Compra</button>

 


<!-- Modal: AGREGAR CATEGORIAS -->
<div class="modal fade" id="modalcompraprov" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <!--Header-->
      <div class="modal-header">
        <h4 class="modal-title" id="myModalLabel">Compra</h4>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
        </button>
      </div>
      <!--Body-->
        <div class="modal-body">

          <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="headers">Registro Productos tienda</div>

                <div class="formbody">

                    <form v-on:submit.prevent="create"  method="post">
                       


                  
                         <div class="form-group row">
                            <label for="proveedor_id" class="col-md-4 col-form-label text-md-right">Proveedor</label>
                          <select v-model="detalle.proveedor_id" >
                               <option disabled value="">Seleccione una proveedor...</option>
                             <option v-for="detalle in proveedores" v-bind:value="detalle.id" name="proveedor_id">
                             {{detalle.nombre}}
                           </option>
                           </select>
                        </div>

                           <div class="form-group row">
                            <label for="producto_id" class="col-md-4 col-form-label text-md-right">Productos</label>
                          <select v-model="detalle.producto_id" >
                               <option disabled value="">Seleccione una producto...</option>
                             <option v-for="detalle in productos" v-bind:value="detalle.id" name="producto_id">
                             {{detalle.nombre}}
                           </option>
                           </select>
                        </div>

                          <div class="form-group row">
                            <label for="cantidad" class="col-md-4 col-form-label text-md-right">Cantidad</label>

                            <div class="col-md-6">
                                <input @change="totals" v-model="detalle.cantidad" id="cantidad" type="number" name="cantidad"  required autocomplete="cantidad" autofocus>                
                            </div>
                        </div>  
                            <div class="form-group row">
                            <label for="precio_venta" class="col-md-4 col-form-label text-md-right">Precio</label>

                            <div class="col-md-6">
                                <input @change="totals" v-model="detalle.precio_venta" id="precio_venta" type="number" name="precio_venta" required autocomplete="precio_venta" >
                            </div>
                        </div>

                          <div class="form-group row">
                            <label for="fecha_compra" class="col-md-4 col-form-label text-md-right">Fecha Compra</label>

                            <div class="col-md-6">
                                <input v-model="detalle.fecha_compra" id="fecha_compra" type="date" name="fecha_compra" required autocomplete="fecha_compra" >
                            </div>
                        </div>

                      

                          <div style="text-align:center" class="form-group row">
                            <label  for="total"  class="col-md-4 col-form-label text-md-right">TOTAL: ${{detalle.total}}</label>
                             <div class="col-md-6">
                              
                            </div>
                        </div>
                            
                       <a href="#"><button  type="submit"  class="btn btn-primary">+ Agregar Detalle</button></a>
                    </form>
                </div>
            </div>
        </div>
    </div>

         </div>

    </div>
  </div>
</div>

		        <form style="margin-left:400px"  id="form" class="form-inline my-2 my-lg-0">
                <input v-model="Search" style="width:55%;" id="control" class="form-control mr-sm-2" type="text" placeholder="Search by nombre">
                <a href="#" class="btn btn-outline-success my-2 my-sm-0" type=""><i class="fa fa-search" aria-hidden="true"></i></a>
            </form>

<table>
				<thead>
					<tr>
						<th>N° FACTURA</th>
            <th>CANTIDAD</th>
						<th>PRECIO</th>
            <th>FECHA DE COMPRA</th>
            <th>PROVEEDOR</th>
            <th>PRODUCTO</th>
             <th>Marca</th>
            <th>CATEGORIA</th>
          <!--  <th>Categoria</th>-->
            <th>TOTAL</th>
            <th>ELIMINAR</th>
					</tr>
				</thead>
    <tbody v-for="detalle in detalles" :key="detalle.id">
          <tr>
            <td >{{detalle.numero_factura}}</td>
            <td >{{detalle.cantidad}}</td>
            <td >${{detalle.precio_venta}}</td>
            <td >{{detalle.fecha_compra}}</td>
            <td >{{detalle.proveedor ? detalle.proveedor.nombre : ''}}</td>
            <td >{{detalle.producto ? detalle.producto.nombre : ''}}</td>
            <td >{{detalle.producto.marca ? detalle.producto.marca.nombre : ''}}</td>
             <td >{{detalle.producto.categoria ? detalle.producto.categoria.nombre : ''}}</td>
        <!--<td >{{detalle.producto ? detalle.producto.categoria_id : '' }}</td>-->
            <td>{{detalle.total}}</td>
            <td><button type="button" class="btn btn-danger" @click="remove(detalle)">Eliminar</button></td>

          </tr>
        </tbody>
			</table>



</div>
</template>

<script>
    export default {	

    	
		data() {
			return {
				csrf: document.head.querySelector('meta[name="csrf-token"]').getAttribute('content'),
			

				detalle:{
					numero_factura:"",
          cantidad:"",
					precio_venta:"",
          fecha_compra:new Date().toISOString().slice(0,10),
          proveedor_id:"",
          producto_id:"",
          total:''
				},
				edit:false,
        Search:'',
        stocks:{},
			     categoria:{
            nombre:""
           },

      }
		},
    props:["detalles","proveedores","productos","categorias"],
		mounted(){
			this.fetchdata();
		},
	 computed:{
     searchuser(){
     if(this.Search){
      let resultados = this.$parent.detalles.filter(c => 
        c.nombre.toLowerCase().startsWith(this.Search));
       
      resultados =[
        ...resultados,
        ...this.$parent.detalles.filter(c => c.apellido.toLowerCase().startsWith(this.Search)),
        ...this.$parent.detalles.filter(c => c.ciudad.name.toLowerCase().startsWith(this.Search)),
        ...this.$parent.detalles.filter(c => c.rut.includes(this.Search)),
      ];
      return [...new Set(resultados)];
     }else{
        return this.$parent.detalles;
      }
    }
  },


		methods:{
			fetchdata(){
				const self = this;
				axios.get('api/showdetalles').then(function(response){
					self.$parent.detalles = response.data.map(function (protienda) {
            return protienda;

          });
					
				})
			},

     remove(detalle) {
                if (confirm("Esta seguro que desea eliminarlo?")) {
                    axios.delete('api/deletefactura/' + detalle.id)
                        this.fetchdata();
                }else{
                      
                }
            },

      create(){
        this.errors=[]
        axios.post("api/compra_prov",this.detalle).then(response=>{
          this.$parent.detalles.push(response.data.detalles);
          this.detalle.numero_factura=""
          this.detalle.cantidad=""
          this.detalle.precio_venta=""
          this.detalle.fecha_compra=""
          this.detalle.proveedor_id=""
          this.detalle.producto_id=""
          this.detalle.total=""
          this.fetchdata();
        }).catch(error=>{
            if(error.response.status==422){
              this.errors=error.response.data.errors
            }
        })
      },

       totals(){
       this.detalle.total=this.detalle.cantidad * this.detalle.precio_venta;
      },
     
    /* sumstock(){
          stocks=this.$parent.producto.stock+this.tienda.cantidad;
     }*/
	}

}

</script>

<style scoped>

body {
  margin: 0;
  background: linear-gradient(45deg, #49a09d, #5f2c82);
  font-family: sans-serif;
  font-weight: 100;
}

.container {
  position: absolute;
  top: 5%;
  left: 5%;
  transform: translate(-50%, -50%);
}

table {
  width:900px;
  margin:0 auto;
  margin-top:2%;
  border-collapse: collapse;
  overflow: hidden;
  box-shadow: 0 0 20px rgba(0,0,0,0.1);
   border-top:2px solid #ccc;
  border-left: 2px solid #ccc;
  margin-bottom:1em;
}
.my-custom-scrollbar {
  height: 500px;
overflow-x:hidden;
overflow: auto;
}
.table-wrapper-scroll-y {
display: block;
}
th,
td {
  padding:20px;
  background-color: rgba(255,255,255,0.2);
  color: #000000;
  padding: 0.5em 1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;

}

th {
    padding: 0.5em 1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;
    white-space: pre;
   background-color: rgba(255,255,255,0.2);
  color: #000000;
}

thead {
  th {
    background-color: rgba(255,255,255,0.2);
  color: #000000;
  }
}

tbody {
  tr {
    &:hover {
      background-color: rgba(255,255,255,0.3);
    }
  }
  td {
    position: relative;
    &:hover {
      &:before {
        content: "";
        position: absolute;
        left: 0;
        right: 0;
        top: -9999px;
        bottom: -9999px;
        background-color: rgba(255,255,255,0.2);
        z-index: -1;
      }
    }
  }
}

.formbody{
  position: relative;
    display: -ms-flexbox;
    display: flex;
    -ms-flex-direction: column;
    flex-direction: column;
    min-width: 0;
    word-wrap: break-word;
    background-color: #fff;
    background-clip: border-box;
    border: 1px solid rgba(0,0,0,.125);
    border-radius: .25rem;
    width:360;
}
.headers {
    position: relative;
    display: -ms-flexbox;
    display: flex;
    -ms-flex-direction: column;
    flex-direction: column;
    min-width: 0;
    word-wrap: break-word;
    background-color: #fff;
    background-clip: border-box;
    border: 1px solid rgba(0,0,0,.125);
    border-radius: .25rem;
    width:360;
}


</style>